.bank
*=$A000
sfnt .incbin "mybol.fnt"
.bank
*=$3000
;$B - mode 6
HSCROL   =   $D404
runs
;------outtext
;scroll_a
 ldx #0
 stx HSCROL
prgr
 lda greetz,X
 sta $CB
 lda #0
 sta $CC

.rept 3
 asl $CB
 ROL $CC
.endr

 lda #$A0
 clc
 adc $CC
 sta $CC
 
 ldy #0
 lda #scroll_a/256
 sta scr_adr+2
charlp
 lda ($CB),y
scr_adr sta scroll_a,X
 inc scr_adr+2
 iny
 cpy #8
 bne charlp
 inx
 bne prgr

;--------------
 ldy #0
fil_600
 lda #$FF
 sta $600,y
 iny 
 bne fil_600
; jmp *
; lda $2000 ; $AD,$00,$20
; eor $2001 ; $4D,$01,$20
; sta $2001 ;$8D,$01,$20
 NMIEN  = $D40E    ; NMI Enable
 VDSLST = $0200    ; DLI Vector
 WSYNC    =   $D40A

charmap=$1000
;---------form EOR loops
;pl_eor
 lda #$00
 sta $CB
 lda #$20
 sta $CC
 jsr mk_eor

 lda putb+1
 sta p24+1

 lda putb+2
 sta p24+2
 
 lda #$00
 sta $CB
 lda #$24
 sta $CC
 jsr mk_eor

;
 lda #dli_12&255
 sta $230

 lda #dli_12/256
 sta $231
;colors
 lda #32 ; 32-red,202/250-green
 sta 708

 lda #144 ; blue
 sta 709

 lda #70 ; 255-yellow
 sta 710

; build charmap
v1 = $CB
bw = $CC
wavcnt = $CD
 lda #0
 sta v1
 tay

chlp2
 lda #charmap&255
 sta chp+1
 lda #charmap/256
 sta chp+2


 ldx #$8
chlp1
 lda v1
 and #$7F
 inc v1
chp sta charmap,y
 lda chp+1
 clc
 adc #32+8
 bcc no_h1
 inc chp+2
no_h1
 sta chp+1
 dex
 bne chlp1
 iny
 cpy #16+24
 bne chlp2
;setup DLI

 LDA #<DLI1
 STA VDSLST
 LDX #>DLI1
 STX VDSLST+1
 
 LDA #$C0
 STA NMIEN

;------------------------------------------------
;755,$D401
wavy_lp
 jsr wait_frame
fontp lda #$20
 sta $D409 ; shadow
 sta dli_fp+1

 eor #$04
 sta fontp+1
 sta fntp+1

; sta dli_fp+1

 cmp #$20
 beq fontc_20
 jsr clear24
 jmp stopc
fontc_20
 jsr clear20
stopc

 lda #$80
 sta wavlp2+1
sv1 ldy #0
 dey
 sty sv1+1
sv2 ldx #0
 inx
 inx
; inx
; inx
 stx sv2+1
 jsr drawsin

 lda #$40
 sta wavlp2+1
sv4 ldy #5
 dey
 dey
 dey
 sty sv4+1
sv5 ldx #7
 inx
 stx sv5+1
 jsr drawsin
 
 lda fontp+1
 cmp #$20
 beq eor_20
p24 jsr wav_lp_e
 jmp wav_lp_e
eor_20 jsr pl_eor;eorfill

wav_lp_e
 jmp wavy_lp

drawsin
; !
fntp lda #0
 sta fontp1+2
 sta fontp2+2
;
 lda #0
 sta sv3+1
 sta fontp1+1
 sta fontp2+1

 lda #$20-1
 sta wavcnt
wavlp2 lda #$80 ; C0, $80
 sta bw
wavlp1
 lda wavsin,X
 clc
 adc wavsin,Y
 clc
sv3 adc #0
 sta fontp1+1
 sta fontp2+1
 lda bw
fontp1 ora $2000
fontp2 sta $2000

.rept 4
 inx ; 4 times?
.endr

.rept 8
 dey
.endr

 lsr bw
 lsr bw
 lda bw
 cmp #0
 bne wavlp1
 lda sv3+1
 clc
 adc #64
 bcc no_h2
 inc fontp1+2
 inc fontp2+2
no_h2
 sta sv3+1

 dec wavcnt
 bpl wavlp2
 rts
;-----clear memory
clear20
 lda #0
 tay
cl20lp
 sta $2000,y
 sta $2080,y

 sta $2100,y
 sta $2180,y
 
 sta $2200,y
 sta $2280,y
 
 sta $2300,y
 sta $2380,y
 iny
 bpl cl20lp
 rts

clear24
 lda #0
 tay
cl24lp
 sta $2400,y
 sta $2480,y

 sta $2500,y
 sta $2580,y

 sta $2600,y
 sta $2680,y

 sta $2700,y
 sta $2780,y

 iny
 bpl cl24lp
 rts
;form lda-eor-sta, 128/8=16
mk_eor
 ldx #0
mkx
 lda #$AD;lda
 jsr putb
 lda $CB
 jsr putb
 lda $CC
 jsr putb
 
 lda $CB
 sta $CD

 lda $CC
 sta $CE

 ldy #0
mky
 inc $CD
 bne no_inc_ce
 inc $CE
no_inc_ce

 lda #$4D;eor
 jsr putb
 lda $CD
 jsr putb
 lda $CE
 jsr putb

 lda #$8D;sta
 jsr putb
 lda $CD
 jsr putb
 lda $CE
 jsr putb
 iny
 cpy #$3F
 bne mky
 lda $CB
 clc
 adc #$40
 bcc no_inc_cc
 inc $CC
no_inc_cc
 sta $CB
 inx
 cpx #16
 bne mkx
 lda #$60
 
;--------------store to routine
putb sta pl_eor
 inc putb+1
 bne end_pb
 inc putb+2
end_pb rts

;------------------------------------------------
wait_frame
RTCLOK = $0012
      lda RTCLOK+2
waits
      cmp RTCLOK+2
       beq waits
 rts
;------------------------------------------------
dli_12
.byte $70,$70,$70
.byte $44+128
.word charmap

.rept 7
.byte 4
.endr

 .byte $4E+128
 .word $600
;-----------mirror-------------------
.byte $44
.word charmap+7*40

.byte $44
.word charmap+6*40

.byte $44
.word charmap+5*40

.byte $44
.word charmap+4*40

.byte $44
.word charmap+3*40

.byte $44
.word charmap+2*40

.byte $44
.word charmap+1*40

.byte $44
.word charmap+0*40
; ----------------------------scroller page------------------------
scroll_a = $1200
hscr = 32/2;hscroll flag
.byte $4B+128
.word $1B00

.byte $4B+hscr;+128
scra0 .word scroll_a+0*256

.byte $4B+hscr
scra1 .word scroll_a+1*256

.byte $4B+hscr
scra2 .word scroll_a+2*256

.byte $4B+hscr
scra3 .word scroll_a+3*256

.byte $4B+hscr
scra4 .word scroll_a+4*256

.byte $4B+hscr
scra5 .word scroll_a+5*256

.byte $4B+hscr
scra6 .word scroll_a+6*256

.byte $4B+hscr
scra7 .word scroll_a+7*256

.byte $41
.word dli_12

greetz
.sbyte "                     "
.sbyte "Greetings to DemoSplash 2015 visitors, JAC!, stRing, Grey/MSB, Heaven/TQA"
.sbyte "                          "
;-----------DL interrupt vectors -----------------------------------
DLI1
 pha
 lda #2
 sta $D401
 sta WSYNC

dli_fp lda #$20
 sta $D409
 sta 756
 sta WSYNC

 LDA #<DLI2
 STA VDSLST
 LDA #>DLI2
 STA VDSLST+1

 pla
 rti

DLI2
 pha
 lda #6
 sta $D401
 sta WSYNC

 lda dli_fp+1
 sta $D409
 sta 756
 sta WSYNC

 LDA #<DLI3
 STA VDSLST
 LDA #>DLI3
 STA VDSLST+1

 pla
 rti

DLI3
 pha
 lda #2
 sta $D401
 sta WSYNC

 lda #$E0
 sta $D409
 sta WSYNC

 LDA #<DLI1
 STA VDSLST
 LDA #>DLI1
 STA VDSLST+1
;-----------scrolly----
 jsr scrollg
 pla
 rti
scrollg
scv1 lda #8
 cmp #0
 bne putsv
 inc scra0
 inc scra1
 inc scra2
 inc scra3
 inc scra4
 inc scra5
 inc scra6
 inc scra7
; lda opcode1+1
; sta scrollg
 lda #8
putsv
 sta scv1+1
 sta HSCROL

 dec scv1+1

 lda #1
 sta WSYNC
opcode1 rts

wavsin
.incbin "wavsin.bin"


pl_eor

.bank
*=$2e0
.word runs